<?php 
// Debug Levels 
CONST DEBUG_NONE	= 0;
CONST DEBUG_ERROR	= 1;
CONST DEBUG_NOTICE	= 2;
CONST DEBUG_DETAIL	= 3;
CONST DEBUG_DEBUG	= 4;

// Transfer Error Codes & Messages
CONST ERR_IncorrectConnectData 	= 20000;
CONST ERR_ActionScriptNotExist 	= 20001;
CONST ERR_ChangeObjectValue 	= 20002;
CONST ERR_ObjectExist 			= 20003;
CONST ERR_LocalForRemoteIDExist = 20004;
CONST ERR_InvalidInstanceStatus = 20005;
CONST ERR_ObjectIsNoInstance 	= 20006;
CONST ERR_ObjectIsNoVariable 	= 20007;
CONST ERR_ConnectionFails		= 20008;
CONST ERR_MessageNoSupported	= 20009;
CONST ERR_CantChangeObjectProps	= 20010;
CONST ERR_ExecuteActionScript   = 20011;
CONST ERR_ExecuteInstanceAction = 20012;
CONST ERR_ExecuteSetValue 		= 20013;
CONST ERR_BeforeLocalDataChanged= 20014;


function GetErrorMessage(int $ErrorCode, $TextOnly=false, $DefaultMsg=''){
	switch ($ErrorCode){
		case ERR_IncorrectConnectData	: $msg="Incorrect connect data received";break;
		case ERR_ActionScriptNotExist	: $msg="Remote ActionScript not exist";break;
		case ERR_ChangeObjectValue		: $msg="Change Object value";break;
		case ERR_ObjectExist			: $msg="Object not exist";break;
		case ERR_LocalForRemoteIDExist	: $msg="No LocalID for RemoteID found";break;
		case ERR_InvalidInstanceStatus	: $msg="Invalid Instance Status";break;
		case ERR_ObjectIsNoInstance		: $msg="Object is not a Instance";break;
		case ERR_ObjectIsNoVariable		: $msg="Object is not a Variable";break;
		case ERR_ConnectionFails		: $msg="Connecion failure";break;
		case ERR_MessageNoSupported		: $msg="MessageID not supported";break;
		case ERR_CantChangeObjectProps	: $msg="Can not get Object settings";break;
		case ERR_ExecuteActionScript   	: $msg="Actionscript Error";break;
		case ERR_ExecuteInstanceAction  : $msg="Instance Action Error";break;
		case ERR_ExecuteSetValue  		: $msg="SetValue Error";break;
		case ERR_BeforeLocalDataChanged	: $msg="OnBeforeLocalDataChanged returns false, skip Dataset";break;
		default: $msg=$DefaultMsg?$DefaultMsg:"Unknow Error";
	}
	return $TextOnly?$msg:"($ErrorCode) $msg";
}


// Message Types
define('DTYPE_MESSAGE',		'M');
define('DTYPE_ERROR',		'E');
define('DTYPE_ACK',			'A');
define('DTYPE_RESPONSE',	'S');
define('DTYPE_REQUEST',		'Q');
define('DTYPE_PING',		'I');
define('DTYPE_PONG',		'O');
define('DTYPE_DESTROY',		'D');

// Request / Rsponse Types
define('RTYPE_SHARES',		'SH');
define('RTYPE_CHANGES',		'CG');
define('RTYPE_CONFIG',		'CF');
define('RTYPE_PROFILE',		'PR');
define('RTYPE_OBJECT',		'OB');
define('RTYPE_CONNECT',		'CO');
define('RTYPE_LINKED',		'LI');
define('RTYPE_COMMAND',		'CM');
define('RTYPE_STATE',		'ST');

// Diff Types
define('DIFF_UPDATE',		0);
define('DIFF_DELETE',		1);
define('DIFF_ADD',			2);
// Data Structure Index  
define('SHARE_OBJ_ID',		"O");
define('SHARE_DIR',			"D");
define('SHARE_TYPE',		"T");
define('SHARE_STATE',		"S");
define('SHARE_PARENT',		"P");
define('SHARE_VTYPE',		"V");
define('SHARE_NAME',		"N");
define('SHARE_LOCALID',		"L");

// Value Type Options
CONST VOPT_ALL			= 0;
CONST VOPT_NAME			= 1;
CONST VOPT_ICON			= 2; 
CONST VOPT_POSITION 	= 4;
CONST VOPT_DISABLED		= 8;
CONST VOPT_IDENT		= 16;
CONST VOPT_HIDDEN		= 32;
CONST VOPT_STATUS		= 64;
CONST VOPT_PROFILE		= 128;
CONST VOPT_VALUE		= 256;




// For Debug messages 

CONST BOOL_TRUEFALSE  	= 0;
CONST BOOL_ERRORJESNO 	= 1;
CONST BOOL_YESNO 		= 2;

/**
 * Be sure that this is not empty is need for all send and receive operations
 * @var string BUFFER_SUFFIX
 */
CONST BUFFER_SUFFIX ='#X#B#';
CONST REMOTEIO_FLUSH_TIMEOUT = 2000;


// Transfer Direction 
CONST DIR_NONE 		= 0;
CONST DIR_STOC 		= 1;
CONST DIR_CTOS 		= 2;
CONST DIR_ALL  		= 3;
// Share States
CONST STATE_READY   = 0;
CONST STATE_CONNECTED=1;
CONST STATE_ERROR   = 2;
CONST STATE_DISABLED= 3;
CONST STATE_CREATE	= 4;
CONST STATE_DESTROY	= 5;

// State colors
CONST COLOR_READY 		= '';
CONST COLOR_CONNECTED	= '#C0FFC0';
CONST COLOR_ERROR  		= '#FFC0C0';
CONST COLOR_DIR_DONE	= '#FFFFC0';
CONST COLOR_DISABLED 	= '#DFDFDF';

// Client States
CONST CLIENT_DISCONNECTED	= 0;
CONST CLIENT_CONNECTED		= 1;
CONST CLIENT_VERIFIED 		= 2;
CONST CLIENT_NOT_ALOWED		= 3;
CONST CLIENT_FAILS			= 4;
CONST CLIENT_CLEANUP		= 5;
// Form constants
const FOMR_CONSOLE = 59;

// INTERNAL Command codes
CONST CMD_SHARES_CHANGED = '#SC#';
CONST CMD_RE_CONNECT	 = '#RC#';

//Command Options
CONST COMMAND_ALLOW_NONE = 0;
CONST COMMAND_ALLOW_IPS  = 1;
CONST COMMAND_ALLOW_ALL  = 2;
//Object Types
CONST OT_CATEGORY 	= 0;
CONST OT_INSTANCE 	= 1;
CONST OT_VARIABLE 	= 2;
CONST OT_SCRIPT 	= 3;
CONST OT_EVENT 		= 4;
CONST OT_MEDIA 		= 5;
CONST OT_LINK 		= 6;

?>